package com.qmth.distributed.print.business.entity;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.distributed.print.business.enums.ExamNumberStyleEnum;
import com.qmth.distributed.print.business.enums.PaperTypeEnum;
import com.qmth.teachcloud.common.base.BaseEntity;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * <p>
 * 题卡规则
 * </p>
 *
 * @author xf
 * @since 2021-03-23
 */
@TableName("basic_card_rule")
public class BasicCardRule extends BaseEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "学校id")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField("school_id")
    private Long schoolId;

    @ApiModelProperty(value = "机构id")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(value = "org_id", updateStrategy = FieldStrategy.IGNORED)
    private Long orgId;

    /**
     * 题卡规则名称
     */
    private String name;
    /**
     * PRINT-印刷条码，PASTE-粘贴条码，FILL-卡号填涂
     */
    @TableField("exam_number_style")
    private ExamNumberStyleEnum examNumberStyle;
    /**
     * PRINT-印刷条码，FILL-卡号填涂
     */
    @TableField("paper_type")
    private PaperTypeEnum paperType;
    /**
     * 0-禁用，1-启用
     */
    @TableField("exam_absent")
    private Boolean examAbsent;
    /**
     * 0-禁用，1-启用
     */
    @TableField("write_sign")
    private Boolean writeSign;

    /**
     * 0-禁用，1-启用
     */
    @TableField("discipline")
    private Boolean discipline;
    /**
     * 必选字段
     */
    @TableField("required_fields")
    private String requiredFields;
    /**
     * 扩展字段
     */
    @TableField("extend_fields")
    private String extendFields;
    /**
     * 题卡标题规则
     */
    @TableField("title_rule")
    private String titleRule;
    /**
     * 注意事项
     */
    private String attention;
    /**
     * 客观题注意事项
     */
    @TableField("objective_attention")
    private String objectiveAttention;
    /**
     * 主观题注意事项
     */
    @TableField("subjective_attention")
    private String subjectiveAttention;
    /**
     * 0-禁用，1-启用
     */
    private Boolean enable = true;
    /**
     * 备注
     */
    private String remark;

    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(exist = false)
    private Long[] orgIds;

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public Long getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(Long schoolId) {
        this.schoolId = schoolId;
    }

    public Long getOrgId() {
        return orgId;
    }

    public void setOrgId(Long orgId) {
        this.orgId = orgId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public ExamNumberStyleEnum getExamNumberStyle() {
        return examNumberStyle;
    }

    public void setExamNumberStyle(ExamNumberStyleEnum examNumberStyle) {
        this.examNumberStyle = examNumberStyle;
    }

    public PaperTypeEnum getPaperType() {
        return paperType;
    }

    public void setPaperType(PaperTypeEnum paperType) {
        this.paperType = paperType;
    }

    public Boolean getExamAbsent() {
        return examAbsent;
    }

    public void setExamAbsent(Boolean examAbsent) {
        this.examAbsent = examAbsent;
    }

    public Boolean getWriteSign() {
        return writeSign;
    }

    public void setWriteSign(Boolean writeSign) {
        this.writeSign = writeSign;
    }

    public Boolean getDiscipline() {
        return discipline;
    }

    public void setDiscipline(Boolean discipline) {
        this.discipline = discipline;
    }

    public String getRequiredFields() {
        return requiredFields;
    }

    public void setRequiredFields(String requiredFields) {
        this.requiredFields = requiredFields;
    }

    public String getExtendFields() {
        return extendFields;
    }

    public void setExtendFields(String extendFields) {
        this.extendFields = extendFields;
    }

    public String getTitleRule() {
        return titleRule;
    }

    public void setTitleRule(String titleRule) {
        this.titleRule = titleRule;
    }

    public String getAttention() {
        return attention;
    }

    public void setAttention(String attention) {
        this.attention = attention;
    }

    public String getObjectiveAttention() {
        return objectiveAttention;
    }

    public void setObjectiveAttention(String objectiveAttention) {
        this.objectiveAttention = objectiveAttention;
    }

    public String getSubjectiveAttention() {
        return subjectiveAttention;
    }

    public void setSubjectiveAttention(String subjectiveAttention) {
        this.subjectiveAttention = subjectiveAttention;
    }

    public Boolean getEnable() {
        return enable;
    }

    public void setEnable(Boolean enable) {
        this.enable = enable;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Long[] getOrgIds() {
        return orgIds;
    }

    public void setOrgIds(Long[] orgIds) {
        this.orgIds = orgIds;
    }
}
